// Copyright 2016 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --harmony-tailcalls --allow-natives-syntax

"use strict";

function h() {
  var stack = (new Error("boom")).stack;
  print(stack);
  v8DeoptimizeFunction(f1);
  v8DeoptimizeFunction(f2);
  v8DeoptimizeFunction(f3);
  v8DeoptimizeFunction(g);
  v8DeoptimizeFunction(h);
  return 1;
}
v8NeverOptimizeFunction(h);

function g(v) {
  return h();
}
v8SetForceInlineFlag(g);


function f1() {
  var o = {};
  o.__defineGetter__('p', g);
  o.p;
}

f1();
f1();
v8OptimizeFunctionOnNextCall(f1);
f1();


function f2() {
  var o = {};
  o.__defineSetter__('q', g);
  o.q = 1;
}

f2();
f2();
v8OptimizeFunctionOnNextCall(f2);
f2();


function A() {
  return h();
}

function f3() {
  new A();
}

f3();
f3();
v8OptimizeFunctionOnNextCall(f3);
f3();
